# -*- coding: utf-8 -*-
"""
Created on Mon Oct 14 09:58:07 2019

@author: icruicks
"""

import networkx as nx, numpy as np
from sktensor import rescal
from sklearn.cluster import KMeans


class rescal_kmeans:
    
    def __init__(self, n_clusters = 10, factor_reg =0, core_reg=0):
        
        self.n_clusters = n_clusters
        self.factor_reg = factor_reg
        self.core_reg = core_reg
    
    def fit_predict(self, base_graphs):
        
        factor_results = rescal.als(base_graphs, self.n_clusters, lambda_A=self.factor_reg,
                                    lambda_R=self.core_reg)
        
        F = factor_results[0]
        clstr = KMeans(n_clusters=self.n_clusters)
        final_clusters = clstr.fit_predict(F)
        return final_clusters
        
        